<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="设备类型" prop="deviceType">
        <el-select v-model="queryParams.deviceType" placeholder="请选择设备类型" clearable>
          <el-option v-for="item in deviceTypeList" :key="item.id" :label="item.typeName" :value="item.id" />
        </el-select>
      </el-form-item>
      <el-form-item label="设备名称" prop="deviceName">
        <el-input
          v-model="queryParams.deviceName"
          placeholder="请输入设备名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
        <el-button type="primary" size="mini" @click="handleAdd">新增巡检单</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="taskList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="报修单编号" align="center" prop="id" />
      <el-table-column label="巡检日期" align="center" prop="pollingData" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.pollingData, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="巡检人" align="center" prop="inspectionUserName" />
      <el-table-column label="设备名称" align="center" prop="deviceName" />
      <el-table-column label="设备编号" align="center" prop="deviceNo" />
      <el-table-column label="巡检状态" align="center" prop="taskState">
        <template slot-scope="scope">{{ selectDictLabels(taskStateList, scope.row.taskState) }}</template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['inspection:task:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改巡检任务对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="110px">
        <el-form-item label="设备类型" prop="deviceType">
          <el-select v-model="form.deviceType" placeholder="请选择设备类型" clearable @change="getDeviceList">
            <el-option v-for="item in deviceTypeList" :key="item.id" :label="item.typeName" :value="item.id" />
          </el-select>
        </el-form-item>
        <el-form-item label="设备名称" prop="deviceId">
          <el-select v-model="form.deviceId" placeholder="请选择设备" clearable>
            <el-option v-for="item in deviceList" :key="item.id" :label="item.deviceName" :value="item.id" />
          </el-select>
        </el-form-item>
        <el-form-item label="设备编号" prop="deviceNo">
          <el-input v-model="form.deviceNo" placeholder="自动获取设备编号" disabled></el-input>
        </el-form-item>
        <el-form-item label="巡检截止日期" prop="pollingData">
          <el-date-picker
            clearable
            v-model="form.pollingData"
            type="date"
            value-format="yyyy-MM-dd"
            placeholder="请选择巡检截止日期"
            :picker-options="pickerOptions"
          ></el-date-picker>
        </el-form-item>
        <el-form-item label="部门名称" prop="maintainDeptId">
          <treeselect
            v-model="form.maintainDeptId"
            :options="deptOptions"
            :normalizer="normalizer"
            placeholder="请选择部门名称"
            @select="deptSelect"
          />
        </el-form-item>
        <el-form-item label="巡检人" prop="inspectionUserId">
          <el-select v-model="form.inspectionUserId" multiple placeholder="请选择巡检人">
            <el-option v-for="item in userList" :key="item.userId" :label="item.nickName" :value="item.userId">
            </el-option>
          </el-select>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listTask, delTask, addTask, updateTask, getInspectionUser } from '@/api/patrol/patrolProject'
import { listDevice as deviceTypeList } from '@/api/device/deviceType'
import { listDevice } from '@/api/device/device'
import { listDept } from '@/api/system/dept'
import { listUser } from '@/api/system/user'
import Treeselect from '@riophae/vue-treeselect'
import '@riophae/vue-treeselect/dist/vue-treeselect.css'
export default {
  components: {
    Treeselect,
  },
  name: 'Task',
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 巡检任务表格数据
      taskList: [],
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        pollingData: null,
        inspectionUserId: null,
        deviceId: null,
        taskState: null,
      },
      queryParamsUser: {
        pageNum: 1,
        pageSize: 100,
        userName: undefined,
        phonenumber: undefined,
        status: undefined,
        deptId: undefined,
      },
      taskStateList: [
        { label: '待巡检', value: 0 },
        { label: '巡检中', value: 1 },
        { label: '已完成', value: 2 },
      ],
      // 表单参数
      form: {},
      deptOptions: [],
      userList: [],
      // 表单校验
      rules: {
        pollingData: [
          {
            required: true,
            message: '巡检截止日期不能为空',
            trigger: 'blur',
          },
        ],
        inspectionUserId: [
          {
            required: true,
            message: '巡检人不能为空',
            trigger: 'blur',
          },
        ],
        deviceType: [
          {
            required: true,
            message: '设备类型不能为空',
            trigger: 'blur',
          },
        ],
        maintainDeptId: [
          {
            required: true,
            message: '部门名称不能为空',
            trigger: 'blur',
          },
        ],
        deviceId: [
          {
            required: true,
            message: '设备名称不能为空',
            trigger: 'blur',
          },
        ],
      },
      // 设备类型列表
      deviceTypeList: [],
      //设备列表
      deviceList: [],
      //用户列表
      useroptions: [],
      // 远程搜索
      loading: false,
      pickerOptions: {
        disabledDate(time) {
          // 禁用今天之前的日期（含今天零点）
          return time.getTime() < new Date(new Date().toLocaleDateString()).getTime()
        },
      },
    }
  },
  created() {
    this.getList()
  },
  methods: {
    // 远程搜索
    remoteMethod(queryString) {
      this.loading = true
      getInspectionUser({
        userName: queryString,
      }).then(response => {
        this.useroptions = response.rows
        this.loading = false
      })
    },
    /** 转换部门数据结构 */
    normalizer(node) {
      if (node.children && !node.children.length) {
        delete node.children
      }
      return {
        id: node.deptId,
        label: node.deptName,
        children: node.children,
      }
    },
    deptSelect(val) {
      this.queryParamsUser.deptId = val.deptId
      this.form.inspectionUserId = null
      this.getUserList()
    },
    /** 查询用户列表 */
    getUserList() {
      listUser(this.addDateRange(this.queryParamsUser)).then(response => {
        this.userList = response.rows
      })
    },
    //根据设备类型查询设备列表
    getDeviceList(val) {
      // 清空部门
      this.deptOptions = []
      const typeDeptIds = this.deviceTypeList.find(item => item.id === val).typeDeptIds
      // 如果有关联的部门ID，则进行查询
      if (typeDeptIds && typeDeptIds.length > 0) {
        //  创建所有 listDept 请求的 Promise 数组
        const deptPromises = typeDeptIds.map(deptId =>
          listDept({ deptId: deptId })
            .then(response => {
              // 处理并返回数据
              return this.handleTree(response.data, 'deptId')
            })
            .catch(error => {
              return [] // 返回空数组，避免 Promise.all 失败
            })
        )
        //等待所有请求完成
        Promise.all(deptPromises)
          .then(deptData => {
            this.deptOptions = deptData.flat()
          })
          .catch(error => {
            console.error('获取部门数据失败:', error)
          })
      }
      this.form.deviceId = null
      this.form.inspectionUserId = null
      listDevice({
        deviceType: this.form.deviceType,
      }).then(response => {
        this.deviceList = response.rows
      })
    },
    /** 查询巡检任务列表 */
    getList() {
      this.loading = true
      listTask(this.queryParams).then(response => {
        this.taskList = response.rows
        this.total = response.total
        this.loading = false
      })
      // 设备类型列表
      deviceTypeList().then(response => {
        this.deviceTypeList = response.rows
      })
      getInspectionUser({
        userName: null,
      }).then(response => {
        this.useroptions = response.rows
      })
    },
    // 取消按钮
    cancel() {
      this.open = false
      this.reset()
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        pollingData: null,
        inspectionUserId: null,
        deviceId: null,
        taskState: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        remark: null,
      }
      this.resetForm('form')
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm')
      this.handleQuery()
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset()
      this.open = true
      this.title = '添加巡检任务'
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs['form'].validate(valid => {
        if (valid) {
          this.form.inspectionUserId = this.form.inspectionUserId.join(',')
          if (this.form.id != null) {
            updateTask(this.form).then(response => {
              this.$modal.msgSuccess('修改成功')
              this.open = false
              this.getList()
            })
          } else {
            addTask(this.form).then(response => {
              this.$modal.msgSuccess('新增成功')
              this.open = false
              this.getList()
            })
          }
        }
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids
      this.$modal
        .confirm('是否确认删除巡检任务编号为"' + ids + '"的数据项？')
        .then(function () {
          return delTask(ids)
        })
        .then(() => {
          this.getList()
          this.$modal.msgSuccess('删除成功')
        })
        .catch(() => {})
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        'inspection/task/export',
        {
          ...this.queryParams,
        },
        `task_${new Date().getTime()}.xlsx`
      )
    },
  },
}
</script>
